//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unnoticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef UNICODE
#define UNICODE
#endif

#ifndef WINDOWS
#define WINDOWS
#include<windows.h>
#endif

#ifndef STRINGR
#define STRINGR
#include<stringR.h>
#endif

#ifndef STRINGLIST
#define STRINGLIST
#include "StringList.h"
#endif


char ReturnDriveLetter(wString &String);

char ReturnDriveLetter(WCHAR *String);

WCHAR *ReturnNetworkDisk(WCHAR *String); // e.g. if \\5.77.192.70\f\test\ returns \\5.77.192.70\f

bool ItIsLocalPath(WCHAR *path);

bool ItIsAbsolutePath(WCHAR *String);

bool ItIsAbsolutePath(wString &String);

wString *ReturnExt(wString &String, wString &Ext);

wString *ReturnFileName(wString &String, wString &Name);


wString *ReturnFilePath(wString &String, wString &Path);


wString *ReturnRelativePath(wString &String, wString &Path);


wString *ReturnRelativeNetworkPath(wString &String, wString &Path);
/*
  e.g. \\5.77.192.70\f\test\ then test\.
*/

bool ItIsFolder(wString &String); //the function it checks if the string ending with an \ or not.

int FolderExists(wString &String); //0 folder 1 not -1 not existing

void IncludeSlash(wString &Path);
/*
  if the path its not terminated with an \ then the function adds it.
*/

int GetFolders(wString &path, StringList &List);
/*
the list will have all the subfolders names of the path return 0 in success -1 for failure
*/

int GetFiles(wString &path, StringList &List, WCHAR *ext);
/*
  the list will have all the files that exists inside the folder.
  if you want to list all the files then in the ext set a *
*/


int GetAllFiles(wString &path, StringList &List,  WCHAR *ext);
/*
 the list will have all the files in all the subfolders as deep as the tree goes. The list will have the full file path e.g. c:\myfolder\test\test1\myfile.txt
 to list all the files in ext set an * .
*/

int GetAllFolders(wString &path, StringList &List);
/*
  the list will have all the subfolders that reside inside the folder as deep as the tree goes. The list will have the full file path e.g. c:\myfolder\test\test1
  returns 0 for success -1 on failure 
*/

int GetAllFilesFolders(wString &path, StringList &FilesList,StringList &FoldersList);
/*
  returns all the files and subfolders that reside inside the folder as deep as the tree goes. The list will have the full file path 
  returns 0 for success -1 for failure .
*/

int ReturnFilesFoldersCount(wString &path,ULONG &filesc,ULONG &foldersc);
/*
   returns the count of all the items inside a folder (files and folders)
*/

int ReturnAllFilesFoldersCount(wString &path,ULONG *filesc,ULONG *foldersc);
/*
      returns the count of all the items inside a folder (files and folders) as deep as the tree goes. 
      the filesc and the foldersc must be zero.
*/

bool cCreateDirPath(WCHAR *dir);
/*
    creates or completes the dir.

*/

bool wDeleteFile(WCHAR *file);// deletes folders and files. if the folder is not empty the routine deletes all the files and then the subfolders before remove the folder.

WCHAR * InsertHugeFilePathPrefix(WCHAR *filename);// the prefix is \\?\
bool FileUnLocked(wString &fname);
bool FileExists(wString &fname);
LARGE_INTEGER FileSize(wString &Fname);


//code

char ReturnDriveLetter(wString &String)
{
     return String[0];
}

char ReturnDriveLetter(WCHAR *String)
{
     return String[0];
}


WCHAR *ReturnNetworkDisk(WCHAR *String)
{

      ULONG indx=0;
      ULONG ret;

      for (int i=0;i<4;i++)
      {
         ret=FindChar(String,L'\\',indx);
         if (ret==-1) break;
      }
      ULONG len=indx-1;
      indx=0;
      WCHAR * temp=CopyToIndex(String,len,indx);

      return temp;



    //e.g. \\5.77.192.70\f\test\ returns \\5.77.192.70\f
}


bool ItIsLocalPath(WCHAR *path)
{

   if (path[1]==L':') return true;
                                else
                                    return false;

}

bool ItIsAbsolutePath(WCHAR *String)
{
    if ((String[1]==L':')&&(String[2]==L'\\'))
    return true;
    else
    return false;
}

bool ItIsAbsolutePath(wString &String)
{
    if ((String[1]==L':')&&(String[2]==L'\\'))
    return true;
    else
    return false;
}

wString *ReturnExt(wString &String, wString &Ext)
{
     bool FoundDot=false;
     ULONG count=(String.GetLength()-1);
     Ext=L"";
  for (int i=count;i>=0;i--)
  {

     if(String[i]==L'.')
     {
       FoundDot=true;
       break;
     }
      Ext+String[i];
  }
     if (FoundDot==false)Ext=L"";
     Ext.Reverse();
     return &Ext;
}


   wString *ReturnFileName(wString &String, wString &Name)
   {

  bool FoundSlash=false;
  ULONG count=(String.GetLength()-1);
  Name=L"";
  if (String[count]==L'\\') count--;

  for (int i=count;i>=0;i--)
  {

     if(String[i]==L'\\')
     {
       FoundSlash=true;
       break;
     };
      Name=Name+String[i];
  }
     if (FoundSlash==false) Name=L"";

     Name.Reverse();
     return &Name;

   }


   wString *ReturnFilePath(wString &String, wString &Path)
   {
           bool FoundSlash=false;
           ULONG count=(String.GetLength()-1);
           ULONG endpos=0;
           Path=L"";

  for (int i=count;i>=0;i--)
  {

     if(String[i]==L'\\')
     {
       FoundSlash=true;
       endpos=i-1;
       break;
     }
  }
     if (FoundSlash==false)Path=L"";
     else
     {

         WCHAR * tmp=new WCHAR[endpos+2];
         tmp[endpos+1]=0;

         CopyStrP(tmp,String.Str(),0,endpos);

         Path=tmp;

         delete [] tmp;


     }
     return &Path;

  }



  wString *ReturnRelativePath(wString &String, wString &Path)
  {


         WCHAR * tmp=new WCHAR[String.GetLength()-2];
         tmp[String.GetLength()-3]=0;

         CopyStrP(tmp,String.Str(),3,String.GetLength()-1);

         Path=tmp;

         delete [] tmp;

        return &Path;

  }


  wString *ReturnRelativeNetworkPath(wString &String, wString &Path)
  {
      ULONG indx=0;
      ULONG ret;

      for (int i=0;i<4;i++)
      {
         ret=FindChar(String.Str(),L'\\',indx);
         if (ret==-1) break;
      }

      if (ret==-1)
      {
          Path=L"$$error$$";
          return &Path;
      }

      WCHAR *tp=CopyToIndex(String.Str(),String.GetLength()-indx,indx);

     // Smessage(tp);

      Path=tp;

      delete [] tp;

      return &Path;




  }

bool ItIsPathFolder(wString &String) 
{
    if (String[String.GetLength()-1]!=L'\\')
    return false;
                else
                    return true;
}

bool ItIsFolder(wString &String) 
{
    if (String[String.GetLength()-1]!=L'\\')
    return false;
                else
                    return true;
}

 int FolderExists(wString &String)
 {

     WCHAR *file=InsertHugeFilePathPrefix(String.Str());
    // Smessage(file);

 HANDLE f=CreateFileW (
          file,
          FILE_LIST_DIRECTORY,
          FILE_SHARE_READ|FILE_SHARE_DELETE,
          NULL,
          OPEN_EXISTING,
          FILE_FLAG_BACKUP_SEMANTICS|FILE_ATTRIBUTE_NORMAL,
          NULL);


    if (f==INVALID_HANDLE_VALUE)
    {
        delete [] file;
      return -1;
    }

             else
                 {
                   CloseHandle(f);
                 }

   if ((GetFileAttributesW(file)&FILE_ATTRIBUTE_DIRECTORY)!=0)
   {
      delete [] file;
      return 0;
   }

   else
   {
      delete [] file;
      return 1;
   }



 }

 void IncludeSlash(wString &Path)
 {

     if (Path[Path.GetLength()-1]!=L'\\')
     Path+L'\\';

 }


int GetFolders(wString &path, StringList &List)
{

   _WIN32_FIND_DATAW Info;
   IncludeSlash(path);
   wString tpath;
   tpath=path;
   tpath+L"*";
   List.ClearList();

   WCHAR *hpath=InsertHugeFilePathPrefix(tpath.Str());

   HANDLE SearcH=FindFirstFileW(hpath,&Info);

   delete [] hpath;

   if(SearcH==INVALID_HANDLE_VALUE) return -1;

   while (FindNextFileW(SearcH,&Info)==true)
   {
       wString tmp;
       tmp=Info.cFileName;
        if (((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0)&&(CompareText(tmp.Str(),L"..")!=0))
        {
         List.Add(tmp.Str());
        }
        tmp.~wString();
   }
   FindClose(SearcH);

   tpath.~wString();
   return 0;

};

int GetFiles(wString &path, StringList &List, WCHAR *ext)
{
      _WIN32_FIND_DATAW Info;

   IncludeSlash(path);

   wString tpath;
   tpath=path;
   tpath+L"*.";
   tpath+ext;
   List.ClearList();

   WCHAR *hpath=InsertHugeFilePathPrefix(tpath.Str());

   HANDLE SearcH=FindFirstFileW(hpath,&Info);

   delete [] hpath;

   if(SearcH==INVALID_HANDLE_VALUE) return -1;

   wString tmp;
   tmp=Info.cFileName;
   if ((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==0)
     List.Add(tmp.Str());

   while (FindNextFileW(SearcH,&Info)==true)
   {
        if (((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==0))
        {
         tmp=Info.cFileName;
         List.Add(tmp);
        }
   }
   tmp.~wString();
   FindClose(SearcH);
   return 0;

};


int GetAllFiles(wString &path, StringList &List, WCHAR *ext)
{
    _WIN32_FIND_DATAW Info;
    IncludeSlash(path);
    wString str;
    str=path;
    str+L"*.*";

    WCHAR *hstr=InsertHugeFilePathPrefix(str.Str());

   HANDLE SearcH=FindFirstFileW(hstr,&Info);

   delete [] hstr;

   if(SearcH==INVALID_HANDLE_VALUE) return -1;

   if ((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==0)
   {
     str=path;
     wString iext;
     wString oext;
     wString tmp;
     oext=ext;
     tmp=Info.cFileName;
     ReturnExt(tmp,iext);
     iext.wUpperCase();
     oext.wUpperCase();
     if((iext==oext)||(oext==L"*"))
     {
       tmp=Info.cFileName;
       List.Add(str+tmp);
     }
     iext.~wString();
     tmp.~wString();
   }
   else
   {
         wString tmp;
         tmp=Info.cFileName;
        if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
        {
         str=path;
         GetAllFiles(str+tmp.Str()+L"\\",List,ext);
        }
        tmp.~wString();

   }

   while (FindNextFileW(SearcH,&Info)==true)
   {
        if (((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==0))
        {
         str=path;
         wString iext;
         wString oext;
         wString tmp;
         oext=ext;
         tmp=Info.cFileName;
         ReturnExt(tmp,iext);
         iext.wUpperCase();
         oext.wUpperCase();
         if((iext==oext)||(oext==L"*"))
         List.Add(str+tmp.Str());
         iext.~wString();
         tmp.~wString();
        }
         else
               {    wString tmp;
                    tmp=Info.cFileName;
                    if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
                    {
                     str=path;
                     GetAllFiles(str+tmp.Str()+L"\\",List,ext);
                    }//if
               }
   }
   FindClose(SearcH);
   str.~wString();
   return 0;

};

int GetAllFolders(wString &path, StringList &List)
{
        _WIN32_FIND_DATAW Info;
   IncludeSlash(path);

    wString str;
    str=path;
    str+L"*.*";

   WCHAR *hstr=InsertHugeFilePathPrefix(str.Str());

   HANDLE SearcH=FindFirstFileW(hstr,&Info);

   delete [] hstr;

   if(SearcH==INVALID_HANDLE_VALUE) return -1;

   if ((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0)
   {
        wString tmp;
        tmp=Info.cFileName;
        if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
        {
          str=path;
          List.Add(str+tmp.Str());
          GetAllFolders(str+L"\\",List);
        }
        tmp.~wString();
   }

   while (FindNextFileW(SearcH,&Info)==true)
   {
        if (((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0))
        {
                wString tmp;
                tmp=Info.cFileName;
                    if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
                    {
                     str=path;
                     List.Add(str+tmp.Str());
                     GetAllFolders(str+L"\\",List);
                    }//if
                tmp.~wString();
               }
   }

   FindClose(SearcH);
   str.~wString();
   return 0;


};

int GetAllFilesFolders(wString &path, StringList &FilesList,StringList &FoldersList)
{
    _WIN32_FIND_DATAW Info;
    IncludeSlash(path);

    wString str;
    str=path;
    str+L"*.*";

    WCHAR *hstr=InsertHugeFilePathPrefix(str.Str());

   HANDLE SearcH=FindFirstFileW(hstr,&Info);

   delete [] hstr;

   if(SearcH==INVALID_HANDLE_VALUE) return -1;

   if ((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0)
   {
        wString tmp;
        tmp=Info.cFileName;
        if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
        {
          str=path;
          FoldersList.Add(str+tmp.Str());
          GetAllFilesFolders(str+L"\\",FilesList,FoldersList);
        }
        tmp.~wString();
   }  else

   {

          wString tmp;
          tmp=Info.cFileName;
          str=path;
          FilesList.Add(str+tmp.Str());
          tmp.~wString();


   }//if files


   while (FindNextFileW(SearcH,&Info)==true)
   {
        if (((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0))
        {
            wString tmp;
            tmp=Info.cFileName;
                    if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
                    {
                     str=path;
                     FoldersList.Add(str+tmp.Str());
                     GetAllFilesFolders(str+L"\\",FilesList,FoldersList);
                    }//if
            tmp.~wString();
        }
        else
        {
            wString tmp;
            tmp=Info.cFileName;
            str=path;
            FilesList.Add(str+tmp.Str());
            tmp.~wString();

        }//if files
   }

   FindClose(SearcH);
   str.~wString();
   return 0;

};



  int ReturnFilesFoldersCount(wString &path,ULONG &filesc,ULONG &foldersc)
    {

   _WIN32_FIND_DATAW Info;
   IncludeSlash(path);
   wString str;
   str=path;
   str+L"*.*";
   foldersc=0;
   filesc=0;

   WCHAR *hstr=InsertHugeFilePathPrefix(str.Str());

   HANDLE SearcH=FindFirstFileW(hstr,&Info);

   delete [] hstr;

   if(SearcH==INVALID_HANDLE_VALUE) return -1;

   if ((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==0)
     filesc++;
     else
     {
         wString tmp;
         tmp=Info.cFileName;
         if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
         foldersc++;
         tmp.~wString();

     }

   while (FindNextFileW(SearcH,&Info)==true)
   {
        if ((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)==0)
       filesc++;
       else
     {
         wString tmp;
         tmp=Info.cFileName;
         if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
         foldersc++;
         tmp.~wString();
     }
   }
   FindClose(SearcH);
   str.~wString();
   return 0;

    };



  int ReturnAllFilesFoldersCount(wString &path,ULONG *filesc,ULONG *foldersc)
    {

   _WIN32_FIND_DATAW Info;
   IncludeSlash(path);

    wString str;
    str=path;
    str+L"*.*";

    WCHAR *hstr=InsertHugeFilePathPrefix(str.Str());

   HANDLE SearcH=FindFirstFileW(hstr,&Info);

    delete [] hstr;

   if(SearcH==INVALID_HANDLE_VALUE) return -1;

   if ((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0)
   {
        wString tmp;
        tmp=Info.cFileName;
        if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
        {
          str=path;
           *foldersc=*foldersc+1;
        ReturnAllFilesFoldersCount(str+tmp.Str()+L"\\",filesc,foldersc);
        }
        tmp.~wString();
   }  else

   {
          str=path;
          *filesc=*filesc+1;


   }//if files

   wString tmp;
   while (FindNextFileW(SearcH,&Info)==true)
   {
        if (((Info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0))
        {
                    tmp=Info.cFileName;
                    if ((CompareText(tmp.Str(),L".")!=0)&&(CompareText(tmp.Str(),L"..")!=0))
                    {
                     str=path;
                     *foldersc=*foldersc+1;
                      ReturnAllFilesFoldersCount(str+tmp.Str()+L"\\",filesc,foldersc);
                    }//if
        }
        else
        {
            str=path;
            *filesc=*filesc+1;

        }//if files
   }

   FindClose(SearcH);
   tmp.~wString();
   str.~wString();
   return 0;

    };



bool cCreateDirPath(WCHAR *dir)
{
wString temp,path;
temp=dir;
if (temp.GetLength()<4)
{
    temp.~wString();
    path.~wString();
    return false;
}


bool localpath=ItIsLocalPath(dir);


if (localpath==true)
{
    ReturnRelativePath(temp,path);
    WCHAR letter[2];
    WCHAR let=ReturnDriveLetter(temp);
    letter[0]=let;
    letter[1]=0;

    temp=letter;
    temp+L":\\";

}
  else
  {
    ReturnRelativeNetworkPath(temp,path);

    WCHAR *let=ReturnNetworkDisk(temp.Str());
    temp=let;
    temp+L"\\";
    delete [] let;
  }


ULONG len=path.GetLength();
ULONG indx=0;

    while(indx<len)
    {
        WCHAR *tmp;
        tmp=CopyStrCh(path.Str(),L'\\',indx);
        temp+tmp;
        delete [] tmp;
        temp+L"\\";
         int res = FolderExists(temp);
         if (res == -1)
         {
            WCHAR *htemp = InsertHugeFilePathPrefix(temp.Str());

                if (CreateDirectory(htemp,NULL)==false)
                {
                   path.~wString();
                   temp.~wString();
                   delete [] htemp;
                   return false;
                }
            delete [] htemp;
         }
    }

path.~wString();
temp.~wString();
return true;

}


WCHAR * InsertHugeFilePathPrefix(WCHAR *filename)
{
    WCHAR pref[5];
    WCHAR UNCPREF[4];

    CopyStr(UNCPREF,L"UNC",4);
    CopyStr(pref,L"\\\\?\\",4);

      if (filename[1]!=L':')

        {
            wString t;
            t=pref;
            t+UNCPREF;
            t+filename;
            ULONG indx=0;
            WCHAR * ret=ReplaceTextw(t.Str(),L"\\\\?\\UNC\\\\",L"\\\\?\\UNC\\",false,indx);
            t.~wString();
            return ret;

        }


    WCHAR * ret = ConCat(pref,filename);

    return ret;

}


 bool FileFolderExists(wString &fname)
 {

	WCHAR * hfname = InsertHugeFilePathPrefix(fname.Str());

	DWORD fileAttr = GetFileAttributesW(hfname);

	delete [] hfname;

		 if (fileAttr==0xFFFFFFFF)
			return false; else
								return true;
 };


 bool wDeleteFile(WCHAR *file)
 {

   StringList folders;
   StringList files;

   wString tfile;
   tfile = file;

   if ( FolderExists(tfile)==1 )
   {
       bool ret;
       WCHAR * tmp = InsertHugeFilePathPrefix(file);


DWORD fileAttr = GetFileAttributes(tmp);

if ((fileAttr & FILE_ATTRIBUTE_READONLY)!=0)
SetFileAttributes(tmp,fileAttr & 0);


       ret = DeleteFile(tmp);

       delete [] tmp;

       tfile.~wString();
       folders.~StringList();
       files.~StringList();
       return ret;
   }

   if (GetAllFilesFolders(tfile,files,folders)== -1)
   {
       tfile.~wString();
       folders.~StringList();
       files.~StringList();
       return false;
   }

 if (files.GetCount()>0)
   for (ULONG i=0;i<=files.GetCount()-1;i++)
   {
       WCHAR * tmp = InsertHugeFilePathPrefix(files[i].Str());

       DWORD fileAttr = GetFileAttributes(tmp);

        if ((fileAttr & FILE_ATTRIBUTE_READONLY)!=0)
        SetFileAttributes(tmp,fileAttr & 0);

        DeleteFile(tmp);

       delete [] tmp;
   }

   if (folders.GetCount()>0)
    for (ULONG i=0;i<=folders.GetCount()-1;i++)
   {
       WCHAR * tmp = InsertHugeFilePathPrefix(folders[i].Str());
       RemoveDirectory(tmp);
       delete [] tmp;
   }

       WCHAR * tmp = InsertHugeFilePathPrefix(file);
       bool ret = RemoveDirectory(tmp);
       delete [] tmp;

     tfile.~wString();
     folders.~StringList();
     files.~StringList();
     return ret;

 }

 bool FileExists(wString &fname)
 {
     WIN32_FIND_DATAW sd;

    WCHAR * hfname = InsertHugeFilePathPrefix(fname.Str());

     HANDLE hnd=FindFirstFileW(hfname,&sd);
     delete [] hfname;

     if (hnd!=INVALID_HANDLE_VALUE)
     {
        FindClose(hnd);
        return true;
     }
       return false;

 }



LARGE_INTEGER FileSize(wString &Fname)
 {
            WCHAR * hfname = InsertHugeFilePathPrefix(Fname.Str());

            HANDLE fh = CreateFileW(hfname, GENERIC_READ, FILE_SHARE_READ, NULL,
                        OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, NULL);

            delete [] hfname;

            LARGE_INTEGER ret;
            ret.QuadPart=-1;

            if ( fh != INVALID_HANDLE_VALUE )

            {

                    DWORD High, Low = GetFileSize(fh, &High);

                    if ( Low != INVALID_FILE_SIZE )

                    {
                        ret.LowPart=Low;
                        ret.HighPart=High;
                        CloseHandle(fh);
                        return ret;
                    }
                    CloseHandle(fh);
            }
    return ret;
 }










