//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unnoticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef UNICODE
#define UNICODE
#endif

#ifndef WINDOWS
#define WINDOWS
#include<windows.h>
#endif

#include<winsock.h>

#ifndef THREADS
#define THREADS
#include <Threads.h>
#endif

#ifndef WSTRING
#define WSTRING
#include <wString.h>
#endif

#ifndef FILESTR
#define FILESTR
#include <filestr.h>
#endif

#ifndef FILEUTILS
#define FILEUTILS
#include <fileutils.h>
#endif



#define MAX_NAME 200
#define MAX_THREADS 200

enum SockType {sClient,sServer};

class NetCon
{
  private:
    WSADATA WSData;
    SockType SType;
    SOCKET Sock;
    SOCKADDR_IN Addr;
    hostent *Host;
    SOCKET *SocketConn;

    Thread *Threads[100];
    Thread MainThread;
    Thread UpD;

    int Port;
    WCHAR HostName[200];
    WCHAR HostIP[15];
    int AF;
    int PType;
    int Protocol;
    int AllowConnections;
    int ActiveConnections;
    bool OnError;
    WCHAR ErrorDesc[255];
    bool Connected;
    ThreadProc ClientProc;
    bool Active;
    void SetError();
    static DWORD MainServerProc(LPVOID pparam);
    static DWORD UpDateProc(LPVOID pparam);
  public:
  struct hostend *host;

    SOCKET GetSocket();
    SockType GetType();
    int GetPort();
    LPCWSTR GetHostName();
    LPCWSTR GetHostIP();
    int GetAF();
    int GetPType();
    int GetProtocol();
    LPCWSTR GetError();
    bool GetOnError();
    bool GetConnected();
    int GetConnections();
    bool GetActive();

    void SetSockType(SockType tp);
    void SetHostName(LPCWSTR HostN);
    void SetHostIP(LPCWSTR IP);
    void SetAF(int af);
    void SetPType(int ptype);
    void SetProtocol(int prot);
    void SetConnections(int Conn);
    bool Connect();
    void Disconnect();
    void Send(char *Buffer,int Len);
    void Rec(char *Buffer,int Len);
    void InitNet();
    void SetClientProc(ThreadProc ClientP);
    void SetPort(int P);

    NetCon(SockType Socktype,int Adrf,int Ptp,int proto);
    ~NetCon();

};


class wFtp
{

    private:
            static const int CR=0xD;
            static const int LF=0xA;
            int sport;
            char resbuff[1024];
            bool asIP;
            wString mess;
            wString IP;
            wString Host;
            wString coms;
            wString user;
            wString pass;
            NetCon commandcon;
            NetCon filescon;
            unsigned long timeo;


    public:

      bool SetServerName(wString host);
      bool SetServerIP(wString host);
      void SetPort(int port);
      void User(wString name);
      void Pass(wString psw);
      void GetResponce(wString &responce);
      bool Connect();
      void Disconnect();
      int SendFile(wString filename,bool reconnect);
      int CreateFolder(wString foldern,bool reconnect);
      int ChangeDirectory(wString todir,bool reconnect);
      void SetConnectionTimeOut(unsigned long to );

      wFtp();
      ~wFtp();

};


LPCWSTR ReturnIP(unsigned long &IP);

LPCWSTR GetMyHostName();

bool IsIPAddress(WCHAR * hst);


//code


SOCKET NetCon::GetSocket()
{
    return Sock;
};

SockType NetCon::GetType()
{
    return SType;
};

int NetCon::GetPort()
{
    return Port;
};

LPCWSTR NetCon::GetHostName()
{
    return HostName;
};

LPCWSTR NetCon::GetHostIP()
{
    return HostIP;
};

int NetCon::GetAF()
{
    return AF;
};

int NetCon::GetPType()
{
    return PType;
};

int NetCon::GetProtocol()
{
    return Protocol;
};

bool NetCon::GetOnError()
{
    bool res=OnError;
    OnError=false;
    return res;
};

LPCWSTR NetCon::GetError()
{
    return ErrorDesc;
};

bool NetCon::GetConnected()
{
    return Connected;
};

int NetCon::GetConnections()
{
    return ActiveConnections;
};

bool NetCon::GetActive()
{
return Active;
};


void NetCon::SetError()
{
 FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,
                                0,
                                WSAGetLastError(),
                                0,
                                ErrorDesc,
                                255,
                                NULL);
};


 void NetCon::SetSockType(SockType tp)
{
   SType=tp;
};

void NetCon::SetHostName(LPCWSTR HostN)
{
    CopyStr(HostName,HostN,MAX_PATH);
};

void NetCon::SetHostIP(LPCWSTR IP)
{
    CopyStr(HostIP,IP,MAX_PATH);
};

void NetCon::SetAF(int af)
{
    AF=af;
};

void NetCon::SetPType(int ptype)
{
    PType=ptype;
};

void NetCon::SetProtocol(int prot)
{
    Protocol=prot;
};


void NetCon::SetConnections(int Conn)
{
    AllowConnections=Conn;
for (int i=0;i<Conn;i++)
Threads[i]=NULL;

};

void NetCon::SetPort(int P)
{
    Port=P;
};

void NetCon::SetClientProc(ThreadProc ClientP)
{
ClientProc=ClientP;
};

void NetCon::InitNet()
{
SType=sClient;
Sock=0;
Host=NULL;
SocketConn=NULL;
for (int i=0;i<MAX_THREADS;i++)Threads[i]=NULL;
    int Port=0;
ZeroMemory(HostName,100*(sizeof(WCHAR)));
ZeroMemory(HostIP,15*(sizeof(WCHAR)));//Host IP
AF=PF_INET;
PType=0;
Protocol=0;
AllowConnections=0;
ActiveConnections=0;
OnError=false;
ZeroMemory(ErrorDesc,255*(sizeof(WCHAR)));
Connected=false;


};

DWORD NetCon::MainServerProc(LPVOID pparam)
{
 SOCKET Client;
NetCon *pthis=(NetCon*)pparam;

while(1)
{
     
Client=accept(pthis->Sock, NULL, NULL);

	if(Client == INVALID_SOCKET)
	{
		CopyStr(pthis->ErrorDesc,L"Error in accept()",17);
        pthis->OnError=true;
        Sleep(1);
	} else

{
if (pthis->ActiveConnections>=pthis->AllowConnections)
{
closesocket(Client);
continue;
}

pthis->ActiveConnections++;
int Index=-1;

    for (int i=0;i<pthis->AllowConnections;i++)
{
    if (pthis->Threads[i]==NULL)
{

    Index=i;
    break;

}//if threads...


}//for i


if (Index!=-1)
{

Thread *t;
SOCKET *s=new SOCKET;
*s=Client;
t=new Thread;
LPVOID p=(LPVOID)s;
t->SetParam(p);
t->SetProc(pthis->ClientProc);

pthis->Threads[Index]=t;
pthis->Threads[Index]->Start();
t=NULL;
s=NULL;

};

Client=0;
}//else

}//while

return 0;
};

DWORD NetCon::UpDateProc(LPVOID pparam)
{

NetCon *pthis=(NetCon*)pparam;

    while(1)
    {

for (int i=0;i<pthis->AllowConnections;i++)
{

Sleep(100);

if (pthis->Threads[i]!=NULL)
if (pthis->Threads[i]->GetExec()==false)
{

(pthis->Threads[i])->Thread::~Thread();
pthis->Threads[i]=NULL;
pthis->ActiveConnections--;
}//if

}//for

    }//while


 return 0;
};



bool NetCon::Connect()
{

 FLOAT SockLibVer;
 WORD Version;
 Connected=false;

    int ERR;

Version=MAKEWORD(1,1);

        if (WSAStartup( Version, &WSData ) != 0 )
        {
        OnError=true;
        CopyStr(ErrorDesc,L"The DLL is unabled to start",27);
        return false;
        };

        SockLibVer = HIBYTE( WSData.wVersion ) / 10.0;
        SockLibVer += LOBYTE( WSData.wVersion );

        if (SockLibVer<1.1)
   {
     OnError=true;
     CopyStr(ErrorDesc,L"The version of the sock library must be >= 1.1",46);
     WSACleanup();
     return false;
   }

       if ( (Sock = socket(AF,PType,Protocol)) == INVALID_SOCKET )

       {
           OnError=true;
           SetError();
           WSACleanup();
           return false;
       }


  switch(SType)
    {
        case sClient:

        Addr.sin_family=AF;
        Addr.sin_port = htons(Port);

        if (HostIP[0]!=0)
        {

        unsigned long *addr=new unsigned long;
        wString temphostip;
        temphostip=HostIP;
        *addr=inet_addr(temphostip.Stra());
        temphostip.~wString();
        Host=gethostbyaddr((char*)addr,4,0);
        delete addr;

        }
        else
        {
            wString temphostip;
            temphostip=HostName;
            Host=gethostbyname(temphostip.Stra());
            temphostip.~wString();
        }

        if (Host==NULL)
        {
           OnError=true;
           SetError();
           WSACleanup();
           return false;
        }

    Addr.sin_addr.s_addr=*((unsigned long *) Host->h_addr);

    if ( (connect(Sock,(struct sockaddr *) &Addr, sizeof(Addr))) != 0)
      {
           OnError=true;
           SetError();
           WSACleanup();
           return false;
        }

        Connected=true;
        Active=true;
      return true;

        break;

        case sServer:

	Addr.sin_family = AF;
	Addr.sin_port = htons(Port);
	Addr.sin_addr.s_addr = INADDR_ANY;

    ERR=bind(Sock,(LPSOCKADDR)&Addr,sizeof(Addr));

    if(ERR == SOCKET_ERROR)
	{
		 OnError=true;
           CopyStr(ErrorDesc,L" Error at bind()",16);
           WSACleanup();
           return false;
	}

    ERR = listen(Sock,AllowConnections);

if(ERR == SOCKET_ERROR)
	{
		 OnError=true;
           CopyStr(ErrorDesc,L"Error at listen()",17);
           WSACleanup();
           return false;
	}

   MainThread.SetProc(MainServerProc);
   LPVOID p=(LPVOID)this;
   MainThread.SetParam(p);
   MainThread.Start();

   UpD.SetProc(UpDateProc);
   UpD.SetParam(p);
   UpD.Start();
Active=true;

return true;
        break;

    };//switch


};



  void NetCon::Disconnect()
{
    switch(SType)
{

case sClient:
if (Connected==true)
{
if (closesocket(Sock)==SOCKET_ERROR)
{
OnError=true;
SetError();
};
WSACleanup();
Active=false;
Connected=false;
}
break;

case sServer:
MainThread.Terminate();
UpD.Terminate();

for (int i=0;i<AllowConnections;i++)
{
if (Threads[i]!=NULL)
{
Threads[i]->Terminate();
Threads[i]->Thread::~Thread();
Threads[i]=NULL;
}
ActiveConnections--;
}

if (closesocket(Sock)==SOCKET_ERROR)
{
OnError=true;
SetError();
}
WSACleanup();
Active=false;
break;

}//switch


};


void NetCon::Send(char *Buffer,int Len)
{

if (SType==sClient)
{
   int res=send(Sock,Buffer,Len,0);
   if(res==SOCKET_ERROR)
{
OnError=true;
SetError();
} else
 if(res==0)
{
 OnError=true;
CopyStr(ErrorDesc,L"The Connection terminated normally",34);
}
}
};

void NetCon::Rec(char *Buffer,int Len)
{
if (SType==sClient)
{
   int res=recv(Sock,Buffer,Len,0);
   if(res==SOCKET_ERROR)
{
OnError=true;
SetError();
} else
    if(res==0)
{
OnError=true;
CopyStr(ErrorDesc,L"The connection terminated normally",34);
}
}
};

NetCon::NetCon(SockType Socktype,int Adrf,int Ptp,int proto)
{

    InitNet();
    SType=Socktype;
    AF=Adrf;
    PType=Ptp;
    Protocol=proto;

};

NetCon::~NetCon()
{
Disconnect();
};


LPCWSTR ReturnIP(unsigned long &IP)
{

int err=0;
WCHAR HostName[MAX_NAME];
hostent *hst;
in_addr adr;


WORD wVersionRequested;
  WSADATA wsaData;

  wVersionRequested = MAKEWORD( 1, 1 );

err=WSAStartup(wVersionRequested,&wsaData);

if (err==WSAEFAULT) return L"WSAEFAULT";
if (err==WSANOTINITIALISED) return L"WSANOTINITIALISED";
if (err==WSAENETDOWN) return L"WSAENETDOWN";
if (err==WSAEINPROGRESS) return L"WSAEINPROGRESS";

char Hostna[200];

err=gethostname(Hostna,MAX_NAME);


if (err==0)

hst=gethostbyname(Hostna);

wString tmpa;
tmpa=Hostna;

CopyStr(HostName,tmpa.Str(),tmpa.GetLength());



if (hst!=0)
{
    char ad[12];
   adr.s_addr =*((unsigned long *) hst->h_addr);
   strcpy(ad,inet_ntoa(adr));
 IP=adr.s_addr;
WSACleanup( );

WCHAR * adw=new WCHAR[16];
ZeroMemory(adw,16*2);

tmpa=ad;

CopyStr(adw,tmpa.Str(),tmpa.GetLength());

tmpa.~wString();

return adw;
};
tmpa.~wString();
WCHAR * adw=new WCHAR[16];
ZeroMemory(adw,16*2);
CopyStr(adw,L"$$ERROR$$",9);
return adw;

};

LPCWSTR GetMyHostName()
{

    int err=0;
WCHAR HostName[MAX_NAME];
hostent *hst;
in_addr adr;


WORD wVersionRequested;
  WSADATA wsaData;

  wVersionRequested = MAKEWORD( 1, 1 );

err=WSAStartup(wVersionRequested,&wsaData);

if (err==WSAEFAULT) return L"$$ERROR$$";
if (err==WSANOTINITIALISED) return L"$$ERROR$$";
if (err==WSAENETDOWN) return L"$$ERROR$$";
if (err==WSAEINPROGRESS) return L"$$ERROR$$";



char HostNa[200];

err=gethostname(HostNa,MAX_NAME);
WSACleanup();

wString tmpa;
tmpa=HostNa;

CopyStr(HostName,tmpa.Str(),tmpa.GetLength());

tmpa.~wString();

return HostName;
}


//wFtp----------------------------------------------------------------------


      bool wFtp::SetServerName(wString host)
      {

            Host=host;
            asIP=false;
      }

      bool wFtp::SetServerIP(wString host)
      {
        IP=host;
        asIP=true;
      }


      void wFtp::SetPort(int port)
      {
         sport=port;
      }

      void wFtp::GetResponce(wString &responce)
      {
         responce=mess;
         mess=L"";
      }

      int wFtp::SendFile(wString filename,bool reconnect)
      {
          wString tmp;
         if ( reconnect==true )
         {
             coms="USER ";
             coms+user;
             coms+(char)CR;
             coms+(char)LF;

             commandcon.Send(coms.Stra(),coms.GetLength());
             ZeroMemory(resbuff,1024);
             commandcon.Rec(resbuff,1024);
             tmp=resbuff;
             mess+tmp;

             coms="PASS ";
             coms+pass;
             coms+(char)CR;
             coms+(char)LF;

             commandcon.Send(coms.Stra(),coms.GetLength());
             ZeroMemory(resbuff,1024);
             commandcon.Rec(resbuff,1024);
             tmp=resbuff;
             mess+tmp;
         }

         coms="TYPE A";
         coms+(char)CR;
         coms+(char)LF;
         commandcon.Send(coms.Stra(),coms.GetLength());
         ZeroMemory(resbuff,1024);
         commandcon.Rec(resbuff,1024);
         tmp=resbuff;
         mess+tmp;


         coms="PASV";
         coms+(char)CR;
         coms+(char)LF;
         commandcon.Send(coms.Stra(),coms.GetLength());
         ZeroMemory(resbuff,1024);
         commandcon.Rec(resbuff,1024);
        // commandcon.Rec(resbuff,1024);



         tmp=resbuff;
         mess+tmp;

         wString temp;
         temp=(char*)resbuff;

         //we get IP and port


          wString i1,i2,i3,i4,p1,p2;

                             unsigned long int ind=0;

                             WCHAR *t;

                             FindChar(temp.Str(),L'(',ind);

                             t=CopyStrCh(temp.Str(),L',',ind);
                             i1=t;
                             delete [] t;
                             ind+1;


                             t=CopyStrCh(temp.Str(),L',',ind);
                             i2=t;
                             delete [] t;
                             ind+1;

                             t=CopyStrCh(temp.Str(),L',',ind);
                             i3=t;
                             delete [] t;
                             ind+1;

                             t=CopyStrCh(temp.Str(),L',',ind);
                             i4=t;
                             delete [] t;
                             ind+1;

                             t=CopyStrCh(temp.Str(),L',',ind);
                             p1=t;
                             delete [] t;
                             ind+1;

                             t=CopyStrCh(temp.Str(),L')',ind);
                             p2=t;
                             delete [] t;

                             wString fIP;
                             fIP=i1+L"."+i2+L"."+i3+L"."+i4;



                             int pn1 = StrToInt(p1.Str());
                             int pn2 = StrToInt(p2.Str());

                             int fport = pn1*256+pn2;

                             temp.~wString();
                            i1.~wString();
                            i2.~wString();
                            i3.~wString();
                            i4.~wString();
                            p1.~wString();
                            p2.~wString();

//-----------------------------------


         coms="STOR ";

         wString fname;

         ReturnFileName(filename, fname);

         coms+fname;
         coms+(char)CR;
         coms+(char)LF;

         fname.~wString();

         commandcon.Send(coms.Stra(),coms.GetLength());

                                    filescon.SetPort(fport);
                                    filescon.SetHostIP(fIP.Str()) ;
                                    if (filescon.Connect()==true)
                                    {
                                        long unsigned int fsize;
                                        char fileb[1024*10];//10 kb

                                        HANDLE fh=Open_File(filename.Str(),RD,FILE_SHARE_READ|FILE_SHARE_WRITE,false);

                                     if (fh!=0)
                                       while(Read_File(fh,fileb,1024*10,fsize)==0)
                                       {
                                         filescon.Send(fileb,fsize);
                                       }
                                       CloseHandle(fh);
                                        filescon.Disconnect();
                                    }

         ZeroMemory(resbuff,1024);
         commandcon.Rec(resbuff,1024);
         tmp=resbuff;
         mess+tmp;

         ZeroMemory(resbuff,1024);
         commandcon.Rec(resbuff,1024);
         tmp=resbuff;
         mess+tmp;

           if (tmp.GetLength()>=3)
           {
               WCHAR resp[5];
               CopyStr(resp,tmp.Str(),4);
               resp[4]=0;
               tmp.~wString();
               return StrToInt(resp);

           } else
           {
               tmp.~wString();
               return 0;
           }


      }

      void wFtp::User(wString name)
      {
          user=name;
      }

      void wFtp::Pass(wString psw)
      {
          pass=psw;
      }

      bool wFtp::Connect()
      {


        commandcon.SetPort(sport);


        if (asIP==true)
        commandcon.SetHostIP(IP.Str());
        else
            commandcon.SetHostName(Host.Str());


            if (commandcon.Connect()!=true)
            {
              mess = commandcon.GetError();
              return false;

            }
             else
                    {
                        //all ok we are connected to the server
                        //set time out

                        DWORD to=timeo;

                       setsockopt(commandcon.GetSocket(),SOL_SOCKET,SO_RCVTIMEO,(char *)&to,sizeof(to));



                         ZeroMemory(resbuff,1024);
                         commandcon.Rec(resbuff,1024);
                         mess=resbuff;

                         if (resbuff[3]=='-')
                             do
                                 {   ZeroMemory(resbuff,1024);
                                     commandcon.Rec(resbuff,1024);
                                     wString t;
                                     t=resbuff;
                                     mess+t;
                                     t.~wString();
                                 } while(resbuff[3]=='-');





                    }


      }

      int wFtp::CreateFolder(wString foldern,bool reconnect)
      {

         wString tmp;
          if ( reconnect==true )
         {
             coms="USER ";
             coms+user;
             coms+(char)CR;
             coms+(char)LF;

             commandcon.Send(coms.Stra(),coms.GetLength());
             ZeroMemory(resbuff,1024);
             commandcon.Rec(resbuff,1024);
             tmp=resbuff;
             mess+tmp;


             coms="PASS ";
             coms+pass;
             coms+(char)CR;
             coms+(char)LF;

             commandcon.Send(coms.Stra(),coms.GetLength());
             ZeroMemory(resbuff,1024);
             commandcon.Rec(resbuff,1024);
             tmp=resbuff;
             mess+tmp;
         }


         coms="MKD ";
         coms+foldern;
         coms+(char)CR;
         coms+(char)LF;
         commandcon.Send(coms.Stra(),coms.GetLength());
         ZeroMemory(resbuff,1024);
         commandcon.Rec(resbuff,1024);
         tmp=resbuff;
         mess+tmp;
          if (tmp.GetLength()>=3)
           {
               WCHAR resp[5];
               CopyStr(resp,tmp.Str(),4);
               resp[4]=0;
               tmp.~wString();
               return StrToInt(resp);

           } else
           {
               tmp.~wString();
               return 0;
           }

      }

      int wFtp::ChangeDirectory(wString todir,bool reconnect)
      {

         wString tmp;
          if ( reconnect==true )
         {
             coms="USER ";
             coms+user;
             coms+(char)CR;
             coms+(char)LF;

             commandcon.Send(coms.Stra(),coms.GetLength());
             ZeroMemory(resbuff,1024);
             commandcon.Rec(resbuff,1024);
             tmp=resbuff;
             mess+tmp;


             coms="PASS ";
             coms+pass;
             coms+(char)CR;
             coms+(char)LF;

             commandcon.Send(coms.Stra(),coms.GetLength());
             ZeroMemory(resbuff,1024);
             commandcon.Rec(resbuff,1024);
             tmp=resbuff;
             mess+tmp;
         }

         coms="CWD ";
         coms+todir;
         coms+(char)CR;
         coms+(char)LF;
         commandcon.Send(coms.Stra(),coms.GetLength());
         ZeroMemory(resbuff,1024);
         commandcon.Rec(resbuff,1024);
         tmp=resbuff;
         mess+tmp;
          if (tmp.GetLength()>=3)
           {
               WCHAR resp[5];
               CopyStr(resp,tmp.Str(),4);
               resp[4]=0;
               tmp.~wString();
               return StrToInt(resp);

           } else
           {
               tmp.~wString();
               return 0;
           }



      }

      void wFtp::Disconnect()
      {

        commandcon.Disconnect();

      }

      void wFtp::SetConnectionTimeOut(unsigned long to )
      {
        timeo=to;
      }

      wFtp::wFtp():commandcon(sClient,AF_INET,SOCK_STREAM,IPPROTO_TCP), filescon(sClient,AF_INET,SOCK_STREAM,IPPROTO_TCP)
      {
          sport=21;
          asIP=false;
          timeo=3000;

      }


      wFtp::~wFtp()
      {


         mess.~wString();
         IP.~wString();
         Host.~wString();
         coms.~wString();
         user.~wString();
         pass.~wString();
         commandcon.~NetCon();
         filescon.~NetCon();

      }


bool IsIPAddress(WCHAR * hst)
{

    if ( StrLen(hst) != 15) return false;

    if ((hst[3] != L'.') || (hst[7] != L'.') || (hst[11] != L'.') ) return false;

    return true ;

}















